// XPCOM components


//*********************************************
//    DEBUG
//*********************************************

var CTBR_debug=true;

function CTBR_alertError(a){
	if(CTBR_debug)alert(a);
}

//*********************************************




function clickCheckBox(pluginname,sId){
	if(pluginname==null)pluginname="";
	var iChecked = document.getElementById(sId).checked;
	//alert(sId+': '+iChecked);
	objShared.SetCfgInt(pluginname,sId,(iChecked)?1:0,1);
}

function setCheckBox(pluginname,sId) {
	if(pluginname==null)pluginname="";
  var res = objShared.GetCfgInt(pluginname,sId,0);
	//alert(document.getElementById(sId).id+':'+res);
  document.getElementById(sId).checked = res;
}


function clickRadio(pluginname,sId){
	try{
		if(pluginname==null)pluginname="";
		var sValue = document.getElementById(sId).value;

		//alert(sId+': '+sValue);
		objShared.SetCfgInt(pluginname,sId,sValue,1);
	}
	catch(e){CTBR_alertError(e)}
}

function setRadio(pluginname,sId) {
	try{
		if(pluginname==null)pluginname="";
		var res = objShared.GetCfgInt(pluginname,sId,0);
		//alert(document.getElementById(sId).id+':'+res);
		var radiogroup=document.getElementById(sId);
		var radios=radiogroup.getElementsByTagName('radio');
		for (var i=0;radios[i];i++){
			if(radios[i].value==res){
				radiogroup.selectedIndex=i;break
			}
		}
	}
	catch(e){CTBR_alertError(e)}
}



//---------------------------------
function setCombo(pluginname,sId) {
	try{
		if(pluginname==null)pluginname="";
		res = objShared.GetCfgStr(pluginname,sId,0);
		//alert(document.getElementById(sId).id+':'+res);
		document.getElementById(sId).value = res;
	}
	catch(e){CTBR_alertError(e)}
}

//---------------------------------
function changeCombo(pluginname,sId) {
	try{
		//alert(sId);
		if(pluginname==null)pluginname="";
		var sValue = document.getElementById(sId).value;
		objShared.SetCfgStr(pluginname,sId,sValue,1);
	}
	catch(e){CTBR_alertError(e)}
}

//---------------------------------



function CTBR_settings_init(){
	try{
		CTBR_XPCOMInit();
		objShared.StartSettings("");

		if (objWSG == null)
		document.getElementById("STWSG_ALL_ROW").hidden = true;
		
		setRadio('TBR','FF_SEARCH');
		setCheckBox('TBR','SHOW_FF_ROOT_BUTTON');
		setCheckBox('TBR','SHOW_FF_CUSTOMIZE');

		setCheckBox('TBR','SHOW_FF_SRCHBOX');
		setCheckBox('TBR','LOOKFOR_ENABLE');
		setCheckBox('STWSG','STWSG_ALL');
		setCheckBox('COMMON','YP_ENABLED');
		setCheckBox('COMMON','WP_ENABLED');

		setCheckBox('COMMON','SHOP_ENABLED');
		setCheckBox('COMMON','GAMES_ENABLED');
		setCheckBox('COMMON','TRAVEL_ENABLED');

		setRadio('TBR','AllowUpdate');


		if(window.arguments&&window.arguments[1]){
			setTimeout(CTBR_Services_Settings,100,window.arguments[1]);
		}

	}
	catch(e){CTBR_alertError(e)}
}

function CTBR_Services_Settings(service){
	window.openDialog("chrome://crawlertbr/content/"+service+"/settings.xul", "", "chrome,titlebar,toolbar,centerscreen,modal");
}

function CTBR_settings_save(showalert){
	try{
		if(showalert==null)showalert=true;
		objShared.ApplySettings("");
		if(showalert)alert(CTBR_Translate('ChangesWillTakeEffectLater'));
		CTBR_update_buttons();
    if (objWSG!=null)
	objWSG.RefreshConfig();
	}
	catch(e){CTBR_alertError(e)}
}

function CTBR_settings_cancel(){
	try{
		objShared.CancelSettings("");
	}
	catch(e){CTBR_alertError(e)}
}

function CTBR_settings_help(url){
	CTBR_settings_openURL(url);
}



function CTBR_settings_openURL(url){
	var parentWindow = window.opener;
	//var newTab = parentWindow.getBrowser().addTab(url);
	//parentWindow.getBrowser().selectedTab = newTab;
	var newWin = parentWindow.open(url,'help','resizable,centerscreen,scrollbars,width=790');
}

function CTBR_Update(){
	objShared.GetText("","UPDATE_NOW","");
}

function CTBR_getBrowserWindows(){
	try{
	var windows=[],wm=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),enumerator=wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()){
		windows.push(enumerator.getNext())
	}
	return windows
	}
	catch(e){CTBR_alertError(e)}
}


function CTBR_update_buttons(){
	try{
	var windows=CTBR_getBrowserWindows();
	for(var win=null,i=0;win=windows[i];++i){
		var ctoolbar=win.document.getElementById('CTBR_Toolbar');
		if(ctoolbar){
			CTBR_LoadButtons(win);
		}
	}
	}
	catch(e){CTBR_alertError(e)}

}


